#include "descriptor/descriptor.h"

int main(void){
	ITEM autom, vetro, abit, interno, asta_specchi, specchiod, specchios, antd_cerchio, antd_gomma, 			ants_cerchio, ants_gomma;
	ITEM postd_cerchio, postd_gomma, posts_cerchio, posts_gomma, luce4, luce1, luce2, luce3, tubo4, 			tubo1, tubo2, tubo3, prato, strada;
	ITEM glass, red, arancio, grigio, nero, rosso_stop;
	ITEM scena;

	set_background(0.6,0.7,0.8,TRUE);
	set_ambient_light(1,1,1,0.5);
	create_point_light(17.084,4.677,10.524,1,1,1,1,120, "l1");
	create_point_light(-22.821,-19.524,4.697,1,1,1,1,0, "l2");
	create_point_light(-2.556,6.170,6.409,1,1,1,1,120, "l3");
	create_point_light(0,0,3,1,1,1,1,150, "l4");

	glass=create_attribute("glass");
	set_color(glass,0.68,0.86,1,0.5,0.5);
	set_reflectivity(glass,0.24,2);
	set_transparency(glass,0.87,0.68,1,1.2);

	red=create_attribute("red");
	set_color(red, 1, 0.1, 0.1, 0.5, 0.5);

	rosso_stop=create_attribute("rosso_stop");
	set_color(rosso_stop, 0.5, 0, 0, 0.5, 0.5);

	nero=create_attribute("nero");
	set_color(nero, 0, 0, 0, 0.5, 0.5);

	arancio=create_attribute("arancio");
	set_color(arancio, 1, 0.5, 0.5, 0.2, 0.5);

	grigio=create_attribute("grigio");
	set_color(grigio, 0.5, 0.5, 0.5, 0.5, 0.5);

	autom = read_nurbs("auto.dbe");
	set_attribute(autom,red);

	vetro=read_nurbs("vetro.db");
	set_attribute(vetro, glass);

	abit=read_obj("abitacolo.obj", "abitacolo");
	set_attribute(abit, grigio);

	interno=read_obj("abitacolo1.obj", "interno");
	set_attribute(interno, arancio);

	asta_specchi=read_obj("asta_specchi.obj", "asta_specchi");
	set_attribute(asta_specchi, arancio);

	specchiod=read_nurbs("specchiettod.db");
	specchios=create_copy(specchiod, "specchios");
	set_translate(specchios,0,2.390,0);
	set_attribute(specchiod, grigio);
	set_attribute(specchios, grigio);

	antd_cerchio=read_nurbs("antd_cerchio.db");
	ants_cerchio=create_copy(antd_cerchio, "ants_cerchio");
	set_translate(ants_cerchio,-2.930,1.389,-0.200);
	set_z_rotate(ants_cerchio,180,1);
	set_translate(ants_cerchio,2.930,1.349,0.180);
	set_attribute(ants_cerchio, grigio);
	set_attribute(antd_cerchio, grigio);

	antd_gomma=read_nurbs("antd_gomma.dbe");
	ants_gomma=create_copy(antd_gomma, "ants_gomma");
	set_translate(ants_gomma,-2.930,1.190,-0.200);
	set_z_rotate(ants_gomma,180,1);
	set_translate(ants_gomma,2.930,1.150,0.180);
	set_attribute(ants_gomma, nero);
	set_attribute(antd_gomma, nero);

	postd_cerchio=read_nurbs("postd_cerchio.db");
	posts_cerchio=create_copy(postd_cerchio, "posts_cerchio");
	set_translate(posts_cerchio,2.002,1.408,-0.180);
	set_z_rotate(posts_cerchio,180,1);
	set_translate(posts_cerchio,-2.020,1.349,0.190);
	set_attribute(posts_cerchio, grigio);
	set_attribute(postd_cerchio, grigio);

	postd_gomma=read_nurbs("postd_gomma.dbe");
	posts_gomma=create_copy(postd_gomma, "posts_gomma");
	set_translate(posts_gomma,2.002,1.156,-0.180);
	set_z_rotate(posts_gomma,180,1);
	set_translate(posts_gomma,-2.020,1.097,0.190);
	set_attribute(posts_gomma, nero);
	set_attribute(postd_gomma, nero);

	luce1=read_nurbs("luce1.db");
	luce2=create_copy(luce1, "luce2");
	luce3=create_copy(luce1, "luce3");
	luce4=create_copy(luce1, "luce4");
	set_translate(luce1, 0.205, 0.600, 0);
	set_translate(luce2, 0.205, -0.600, 0);
	set_translate(luce3, 0.205, 0.900, 0);
	set_translate(luce4, 0.205, -0.900, 0);
	set_attribute(luce1, rosso_stop);
	set_attribute(luce2, rosso_stop);
	set_attribute(luce3, arancio);
	set_attribute(luce4, arancio);

	tubo1=read_nurbs("tubo1.db");
	tubo2=create_copy(tubo1, "tubo2");
	tubo3=create_copy(tubo1, "tubo3");
	tubo4=create_copy(tubo1, "tubo4");
	set_translate(tubo1, 0, 0.140, 0);
	set_translate(tubo2, 0, -0.140, 0);
	set_translate(tubo3, 0, 0.365, 0);
	set_translate(tubo4, 0, -0.365, 0);
	set_attribute(tubo1, grigio);
	set_attribute(tubo2, grigio);
	set_attribute(tubo3, grigio);
	set_attribute(tubo4, grigio);

	strada=read_nurbs("strada.db");
	set_translate(strada, 0, 0, -0.5);
	set_attribute(strada, grigio);
	prato=read_nurbs("prato.db");
	set_translate(prato, 0, 0, -0.51);
	set_attribute(prato, nero);
	set_projection_texture(strada,red,"textures/marble_5_black.hr",0,2,0.6,0.8);
	set_projection_texture(prato,red,"textures/piante.hr",0,2,0.6,0.8);

	scena = create_list(autom, "scena");
	scena=insert_in_list(scena, vetro);
	scena=insert_in_list(scena, abit);
	scena=insert_in_list(scena, interno);
	scena=insert_in_list(scena, asta_specchi);
	scena=insert_in_list(scena, specchiod);
	scena=insert_in_list(scena, specchios);
	scena=insert_in_list(scena, antd_cerchio);
	scena=insert_in_list(scena, ants_cerchio);
	scena=insert_in_list(scena, antd_gomma);
	scena=insert_in_list(scena, ants_gomma);
	scena=insert_in_list(scena, postd_cerchio);
	scena=insert_in_list(scena, posts_cerchio);
	scena=insert_in_list(scena, postd_gomma);
	scena=insert_in_list(scena, posts_gomma);
	scena=insert_in_list(scena, luce1);
	scena=insert_in_list(scena, luce2);
	scena=insert_in_list(scena, luce3);
	scena=insert_in_list(scena, luce4);
	scena=insert_in_list(scena, tubo1);
	scena=insert_in_list(scena, tubo2);
	scena=insert_in_list(scena, tubo3);
	scena=insert_in_list(scena, tubo4);
	scena=insert_in_list(scena, prato);
	scena=insert_in_list(scena, strada);

	save_scene("F330.md","auto",scena);
	return(0);
}
